# Copyright 2006-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/dev-cpp/sptk/sptk-3.5.1.ebuild,v 1.1 2007/06/05 22:58:46 iluxa Exp $

inherit subversion

ESVN_REPO_URI="https://gateway.total-knowledge.com/svn/sptk3/trunk"
ESVN_PROJECT="sptk3"
#ESVN_BOOTSTRAP="./autogen.bash"
ESVN_BOOTSTRAP="cmake -D CMAKE_INSTALL_PREFIX:PATH=/usr ."

IUSE="fltk odbc doc sqlite3 excel postgres"

DESCRIPTION="C++ user interface toolkit for X with database and Excel support"
HOMEPAGE="http://www.sptk.net"

SLOT="3"
LICENSE="|| ( BSD )"
KEYWORDS="~alpha ~amd64 ~mips ~ppc ~sparc ~x86"

DEPEND="dev-util/cmake
        fltk?     ( >=x11-libs/fltk-1.1.6 )
	odbc?     ( >=dev-db/unixODBC-2.2.6 )
	sqlite3?  ( >=dev-db/sqlite-3 )
	postgres? ( >=dev-db/libpq-8.0 )
	aspell?   ( >=app-text/aspell-0.50 )
	doc?      ( app-doc/doxygen )"

src_unpack() {
    if use examples; then
        SPTK_EXAMPLES="-D NO_EXAMPLES=FALSE"
    else
        SPTK_EXAMPLES="-D NO_EXAMPLES=TRUE"
    fi

    if use postgres; then
        SPTK_POSTGRES="-D NO_POSTGRES=FALSE"
    else
        SPTK_POSTGRES="-D NO_POSTGRES=TRUE"
    fi

    if use sqlite3; then
        SPTK_SQLITE3="-D NO_SQLITE3=FALSE"
    else
        SPTK_SQLITE3="-D NO_SQLITE3=TRUE"
    fi

    if use odbc; then
        SPTK_ODBC="-D NO_ODBC=FALSE"
    else
        SPTK_ODBC="-D NO_ODBC=TRUE"
    fi

    if use aspell; then
        SPTK_ASPELL="-D NO_ASPELL=FALSE"
    else
        SPTK_ASPELL="-D NO_ASPELL=TRUE"
    fi

    if use fltk; then
        SPTK_FLTK="-D NO_FLTK=FALSE"
    else
        SPTK_FLTK="-D NO_FLTK=TRUE"
    fi

    if use excel; then
        SPTK_EXCEL="-D NO_EXCEL=FALSE"
    else
        SPTK_EXCEL="-D NO_EXCEL=TRUE"
    fi

    SPTK_FLAGS="${SPTK_EXAMPLES} ${SPTK_POSTGRES} ${SPTK_SQLITE3} ${SPTK_ODBC} ${SPTK_ASPELL} ${SPTK_FLTK}"
    ESVN_BOOTSTRAP="cmake -D CMAKE_INSTALL_PREFIX:PATH=/usr ${SPTK_FLAGS} ."

    subversion_src_unpack

    # We need to create the ChangeLog here
    #TZ=UTC svn log -v "${ESVN_REPO_URI}" >ChangeLog
}

src_compile() {
    emake || die "Parallel Make Failed"

    if use doc; then
	cd "${S}"
	einfo "Fixing sptk3.doxygen"
	sed -i -e 's,/cvs/sptk3/,,g' sptk3.doxygen
	einfo "Building docs"
	doxygen sptk3.doxygen
    fi
}

src_install () {
    make DESTDIR=${D} install || die "Installation failed"

    dodoc README AUTHORS

    dodir /usr/share/doc/${PF}
    cp -r ${S}/docs/* ${D}/usr/share/doc/${PF}
    if use doc; then
	rm -fr ${D}/usr/share/doc/${PF}/latex
	cp -r ${S}/pictures ${D}/usr/share/doc/${PF}
    fi
}
