/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          debugmacros.h  -  description
                             -------------------
    begin                : Thu Oct 17 2002
    copyright            : (C) 2002-2007 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __DEBUGMACROS_H__
#define __DEBUGMACROS_H__

#ifdef DEBUG
#include <stdio.h>

#define DEBUG_MESSAGE(str) printf("%s",str); fflush(stdout);
#define DEBUG_MESSAGE_LN(str) printf("%s\n",str);
#define DEBUG_MESSAGE_FLN(str) printf("%s (%i): %s\n",__FILE__,__LINE__,str);
#define DEBUG_STRING(name,str) printf("%s: %s",name,str); fflush(stdout);
#define DEBUG_STRING_LN(name,str) printf("%s: %s\n",name,str);
#define DEBUG_INTEGER(name,value) printf("%s: %i",name,value); fflush(stdout);
#define DEBUG_INTEGER_LN(name,value) printf(" %s: %i\n",name,value);
#define DEBUG_DOUBLE(name,str) printf("%s: %0.2f",name,double(value)); fflush(stdout);
#define DEBUG_DOUBLE_LN(name,value) printf("%s: %0.2f\n",name,double(value));
#else
#define DEBUG_MESSAGE(str) ;
#define DEBUG_MESSAGE_LN(str) ;
#define DEBUG_STRING(name,str) ;
#define DEBUG_STRING_LN(name,str) ;
#define DEBUG_INTEGER(name,value) ;
#define DEBUG_INTEGER_LN(name,value) ;
#define DEBUG_DOUBLE(name,str) ;
#define DEBUG_DOUBLE_LN(name,value) ;
#endif

#endif
