/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CExcelCell.h  -  description
                             -------------------
    begin                : Mon Jan 19 2004
    copyright            : (C) 2004 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __CEXCELCELL_H__
#define __CEXCELCELL_H__

#include <sptk3/CVariant.h>
#include <sptk3/excel/CExcelCellFormat.h>

namespace sptk {

/// @addtogroup excel Excel Classes
/// @{

/// Represents an Excel cell in the memory
class CExcelCell : public CVariant {
    const CExcelCellFormat *m_format;  ///< An optional pointer to the cell format
public:
    /// Constructor
    CExcelCell() {
        m_format = 0L;
    }

    /// Advanced copy constructor
    /// @param v const CVariant&, data to copy from
    /// @param format const CExcelCellFormat *, a cell format
    CExcelCell(const CVariant& v,const CExcelCellFormat *format=0L) : CVariant(v) {
        m_format = format;
    }

    /// Sets the cell format. NULL means the default formatting
    /// @param format const CExcelCellFormat *, a cell format
    void format(const CExcelCellFormat *format) {
        m_format = format;
    }

    /// Returns the cell format. NULL means the default formatting
    const CExcelCellFormat *format() const {
        return m_format;
    }
};
/// @}
}
#endif
