/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CExcelRows.h  -  description
                             -------------------
    begin                : July 31 2005
    copyright            : (C) 2005 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __CEXCELROWS_H__
#define __CEXCELROWS_H__

#include <sptk3/excel/CExcelRow.h>

namespace sptk {

/// @addtogroup excel Excel Classes
/// @{

/// Defining CExcelRows as a vector of CExcelRow objects
class CExcelRows {
    typedef std::vector<CExcelRow *> CExcelRowVector;
    CExcelRowVector m_rows;
public:
    /// Default constructor
    CExcelRows() {}

    /// Element access
    CExcelRow& operator [] (uint32_t i) {
        return *m_rows[i];
    }

    /// Const element access
    const CExcelRow& operator [] (uint32_t i) const {
        return *m_rows[i];
    }

    /// Destructor
    ~CExcelRows() {
        for (CExcelRowVector::iterator itor = m_rows.begin(); itor != m_rows.end(); itor++)
            delete *itor;
    }

    /// Resize a rowset
    void resize(uint32_t newSize);

    /// Returns size (number oif rows)
    uint32_t size() const {
        return (uint32_t) m_rows.size();
    }
};
/// @}
}
#endif
