/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CPopupWindow.h  -  description
                             -------------------
    begin                : Tue Apr 4 2000
    copyright            : (C) 2000-2007 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __CPOPUPWINDOW_H__
#define __CPOPUPWINDOW_H__

#include <sptk3/gui/CWindow.h>
#include <sptk3/sptk.h>

namespace sptk {

/// @addtogroup gui GUI Classes
/// @{

/// @brief Base popup window
///
/// The CWindow descendant that closes the window if the user
/// clicks outside of it with mouse or moves the focus outside
/// the window any other way
class SP_EXPORT CPopupWindow : public CWindow {
protected:
    /// The outside mouse click
    int  m_clicked;
    /// The special handle() function
    int  handle(int);
public:
    /// Constructor
    /// @param w int, window width
    /// @param h int, window height
    /// @param label int, window label
    CPopupWindow(int w, int h, const char *label = 0);

    /// Shows window in modal mode. Exits from the modal mode
    /// when the focus is moved outside the window.
    bool showModal();
};
/// @}
}
#endif
