/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CShapePoint.h  -  description
                             -------------------
    begin                : Oct 23 2006
    copyright            : (C) 2006-2007 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __CSHAPEPOINT_H__
#define __CSHAPEPOINT_H__

namespace sptk {

/// @addtogroup gui GUI Classes
/// @{

#ifdef _WIN32
typedef int32_t COORD;
#else
/// @brief Coordinate type for shapes
typedef int16_t COORD;
#endif

/// @brief A point to define a shape
class CShapePoint {
public:
    COORD       x;  ///< X-coordinate
    COORD       y;  ///< Y-coordinate
public:
    /// @brief Default constructor
    /// @param _x COORD, X-coordinate
    /// @param _y COORD, Y-coordinate
    CShapePoint(COORD _x=0,COORD _y=0) {
        x = _x;
        y = _y;
    }
    /// @brief Copy constructor
    /// @param p const CPoint&, point to copy from
    CShapePoint(const CShapePoint& p) {
        x = p.x;
        y = p.y;
    }
};
/// @}
}
#endif
