/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CXml.h  -  description
                             -------------------
    begin                : Sun May 22 2003
    based on the code    : Mikko Lahteenmaki <Laza@Flashmail.com>
    copyright            : (C) 2003-2007 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#ifndef __CXML_H__
#define __CXML_H__

#include <sptk3/xml/CXmlDoc.h>
#include <sptk3/xml/CXmlNode.h>

namespace sptk {

/// @addtogroup XML
/// @{

/// @brief XML exception
///
/// Xml extension throws CXmlException type exceptions.
/// You should catch always atleast these type of exceptions, when processing XML.
class SP_EXPORT CXmlException : public std::exception {
    std::string     m_message; ///< Exception text
public:

    /// @brief Constructor
    /// @param error const char*, error text
    /// @param xmlbase const char*, parsed xml text
    /// @param position const char*, parsed xml error position
    CXmlException(const char* error,const char* xmlbase,const char* position);

    /// @brief Destructor
    ~CXmlException() throw() {
    }

    /// Returns human readable error string.
    const char *what() const throw() {
        return m_message.c_str();
    }
};
/// @}
}
#endif
