/***************************************************************************
                          SIMPLY POWERFUL TOOLKIT (SPTK)
                          CImapDS.cpp - description
                             -------------------
    begin                : Mar 19 2003
    copyright            : (C) 2003-2007 by Alexey Parshin. All rights reserved.
    email                : alexeyp@gmail.com
 ***************************************************************************/

/***************************************************************************
  Redistribution and use in source and binary forms, with or without 
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, 
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.
  * Neither the name of the <ORGANIZATION> nor the names of its contributors 
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************************************************************************/

#include <sptk3/CImapDS.h>
#include <sptk3/CException.h>

#include <stdlib.h>

#ifndef _WIN32
# include <unistd.h>
#endif

using namespace sptk;

// read the folder() and move item into the first entry
bool CImapDS::open() {
   clear();

    // Connect to the server
   m_imap.cmd_login(m_user,m_password);

    // Select the mail box
   int32_t total_messages, first_message = 1;
   m_imap.cmd_select(m_folder,total_messages);

   if (m_msgid) {
      first_message = m_msgid;
      total_messages = m_msgid;
   }
   if (total_messages) {
      if (m_callback)
         m_callback(total_messages,0);
      for (long msg_id = first_message; msg_id <= total_messages; msg_id++) {
         CFieldList   *df = new CFieldList(false);

         df->user_data((void *)(size_t)msg_id);

         if (m_fetchbody)
            m_imap.cmd_fetch_message(msg_id,*df);
         else m_imap.cmd_fetch_headers(msg_id,*df);

         CField *fld = new CField("msg_id");
         fld->width = 0;
         fld->setInteger(msg_id);
         df->push_back(fld);

         m_list.push_back(df);

         if (m_callback)
            m_callback(total_messages,msg_id);
      }
      if (m_callback)
         m_callback(total_messages,total_messages);
   } else {
      if (m_callback)
         m_callback(100,100);
   }

   first();

   m_imap.cmd_logout();
   m_imap.close();

   m_eof = m_list.size() == 0;

   return !m_eof;
}
